//=============================================================================
// Change_ErrorLogging.js
//   Last update: 2024/09/15
//=============================================================================
// 更新っぽいもの
// 
// 2024/09/15 [v0.1.0]
// 初版

/*:
 * @plugindesc
 * [v0.1.0] Change!! ErrorLogging.
 * 
 * @author Diamond
 *
 * @param File Name
 * @text ????
 * @default error_log
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Extended Child
 * @text ????
 * @default txt
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 * 
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 */

/*:ja
 * @plugindesc
 * [v0.1.0] 真（チェンジ！！）エラーロギング
 * 
 * @author 貪藻矢射妥←
 *
 * @param File Name
 * @text ファイル名
 * @default error_log
 * @desc ログ出力ファイル名設定
 *
 * @param Extended Child
 * @text 拡張（された）子（供）
 * @default txt
 * @desc ログ出力ファイル拡張子の設定
 *
 * @help
 * エラー発生時にログを外部出力します。
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 */

var OuterFlg = OuterFlg || {};

(function() {

OuterFlg.imported = OuterFlg.imported || {};
OuterFlg.imported['ErrorLogging'] = true;

const fs = require('fs');

/*
 * エラーロギング
 */
var setErrorLogging = function(msgList) {
    var saveFile = './' + changeErrorLoggingFileName + '.' + changeErrorLoggingExtendedChild;
    var date = new Date();
    var header = '+-------------------------------------------- ' + date + ' -+\r\n';
    
    alert(msgList);
    
    fs.appendFileSync(saveFile, header, 'utf-8');
    
    fs.appendFileSync(saveFile, msgList, 'utf-8');
    
    fs.appendFileSync(saveFile, '\r\n\r\n', 'utf-8');
};

var pluginParams = PluginManager.parameters('Change_ErrorLogging');
var changeErrorLoggingFileName      = pluginParams['File Name'] || 'error_log';
var changeErrorLoggingExtendedChild = pluginParams['Extended Child'] || 'txt';


/**
 * @static
 * @method _makeErrorHtml
 * @param {String} name
 * @param {String} message
 * @return {String}
 * @private
 */
Graphics._makeErrorHtml = function(name, message) {
    var msgList = [name, message];
    setErrorLogging(msgList);
    
    return ('<font color="yellow"><b>' + name + '</b></font><br>' +
            '<font color="white">' + message + '</font><br>');
};


})();
